<% @Language=VBScript %>
<%  
    ' The embedded database engine
    Set db = Server.CreateObject("newObjects.sqlite.dbutf8")
    ' Configure the database for automatic type conversions of the returned results
    ' These are the recommended settings
    db.AutoType = True
    db.TypeInfoLevel = 4
    
    ' The string formatting object we will use to create the more complicated queries
    Set su = Server.CreateObject("newObjects.utilctls.StringUtilities")
    
    ' Open our database
    db.Open Server.MapPath("db1.scdb")
    
    ' Process any actions invoked by the user
    If Request("Add").Count > 0 Then
        db.Execute su.Sprintf("INSERT INTO Person (NAME1,NAME2,NAME3,EMAIL) VALUES(%q,%q,%q,%q)", _
                    Request("NAME1"),Request("NAME2"),Request("NAME3"),Request("EMAIL"))
    ElseIf Request("Update").Count > 0 Then
        db.Execute su.Sprintf("UPDATE Person SET NAME1=%q, NAME2=%q, NAME3=%q, EMAIL=%q WHERE PersonID=%u", _
                    Request("NAME1"),Request("NAME2"),Request("NAME3"),Request("EMAIL"),Request("PERSONID"))
    ElseIf Request("Delete").Count > 0 Then
        db.Execute "DELETE FROM Person WHERE PersonID=" & Request("PersonID")
    End If
    
    
    ' Determine if we the user has requested an ordering
    orderBy = ""
    If Request("OrderBy") <> "" Then orderBy = " ORDER BY " & Request("OrderBy")
    
    ' Determine on which page are we
    Page = 1
    If Request("Page") <> "" Then Page = CLng(Request("Page"))
    
    ' Fetch the persons for the current page
    ' We request only 10 records beginning from the first record for the current page
    Set rPersons = db.Execute("SELECT * FROM Person" & orderBy,(Page - 1) * 10,10)
    ' We will use rPersons below to list the persons
    
    ' Determine the number of the pages
    PersonsCount = db.Execute("SELECT COUNT(*) FROM Person")(1)(1)
    ' Note that we use (1)(1) which means: First record, first field.
    ' For the query above we are absolutely sure that it will return one record with one field
    ' so it is safe to do everything in one line of code.
    PageCount = PersonsCount / 10 + 1
    
%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<meta http-equiv="Content-Type" content="text/html; charset=windows-1252">
<title>List of the people in the database</title>
</head>

<body>

<p>List of the people in the database.</p>
<table border="1" width="100%" cellspacing="1">
  <tr>
    <td valign="top" align="left">&nbsp;</td>
    <td valign="top" align="left">First name</td>
    <td valign="top" align="left">Middle name</td>
    <td valign="top" align="left">Last name</td>
    <td valign="top" align="left">e-mail</td>
    <td valign="top" align="left">Action</td>
  </tr>
  <% For I = 1 To rPersons.Count %>
      <FORM METHOD="POST" ACTION="<%= Request.ServerVariables("SCRIPT_NAME") %>">
      <INPUT TYPE="HIDDEN" NAME="PERSONID" VALUE="<%= rPersons(I)("PERSONID") %>">
      <tr>
        <td valign="top" align="left"><a href="person-experience.asp?PersonID=<%= rPersons(I)("PERSONID") %>">Experience</a></td>
        <td valign="top" align="left"><input type="text" size="20" name="NAME1" 
            VALUE="<%= Server.HTMLEncode(rPersons(I)("NAME1")) %>"></td>
        <td valign="top" align="left"><input type="text" size="20" name="NAME2"
            VALUE="<%= Server.HTMLEncode(rPersons(I)("NAME2")) %>"></td>
        <td valign="top" align="left"><input type="text" size="20" name="NAME3"
            VALUE="<%= Server.HTMLEncode(rPersons(I)("NAME3")) %>"></td>
        <td valign="top" align="left"><input type="text" size="20" name="EMAIL"
            VALUE="<%= Server.HTMLEncode(rPersons(I)("EMAIL")) %>"></td>
        <td valign="top" align="left">
            <input type="submit" value="Update" name="Update">
            <input type="submit" value="Delete" name="Delete">
        </td>
      </tr>
      </FORM>
  <% Next %>
  
  <% If PageCount > 1 Then 
        ' Take care to transfer the non-page oriented important parameters - such as order
        strParams = ""
        If Request("OrderBy") <> "" Then strParams = "&OrderBy=" & Request("OrderBy")
  %>
  <TR>
    <TD COLSPAN="6">
        Pages:
        <% For I = 1 To PageCount %>
            <% If Page = I Then %>
                <B><%= I %></B>
            <% Else %>
                <A HREF="<%= Request.ServerVariables("SCRIPT_NAME") %>?Page=<%= I %><%= strParams %>"><%= I %></A>&nbsp;
            <% End If %>
        <% Next %>
    </TD>
  </TR>
  <% End If %>
  
  <FORM METHOD="POST" ACTION="<%= Request.ServerVariables("SCRIPT_NAME") %>">
  <tr>
    <td valign="top" align="left" bgcolor="#D5DDCC">&nbsp;</td>
    <td valign="top" align="left" bgcolor="#D5DDCC"><input type="text" size="20" name="NAME1"></td>
    <td valign="top" align="left" bgcolor="#D5DDCC"><input type="text" size="20" name="NAME2"></td>
    <td valign="top" align="left" bgcolor="#D5DDCC"><input type="text" size="20" name="NAME3"></td>
    <td valign="top" align="left" bgcolor="#D5DDCC"><input type="text" size="20" name="EMAIL"></td>
    <td valign="top" align="left" bgcolor="#D5DDCC"><input type="submit" value="Add" name="Add"></td>
  </tr>
  </FORM>
</table>

</body>

</html>
